#include <stdio.h>

typedef enum {atom, list} NODETYPE;
typedef struct listnode *NODEPTR;

struct listnode
  {
    NODETYPE type;
    union { int value; NODEPTR first; } data;
    NODEPTR next;
  };

void printlist(NODEPTR root)
  {
    register NODEPTR p;

    printf("( ");
    for (p = root; p != NULL; p = p->next)
      switch (p->type)
        {
          case list:
              printlist(p->data.first);
              break;
          case atom:
              printf("%d ", p->data.value);
              break;
          default:
              printf("\nfunny node\??!\n");
              return;
        }
    printf(") ");
  }

#define START -1
#define END   -2
NODEPTR mklist(void)
  {
    NODEPTR  p, oldp, head = NULL;
    int val;
    char *malloc(int);

    for (oldp = NULL; (scanf("%d", &val), val != END); oldp = p)
      {
        p = (NODEPTR) malloc(sizeof(struct listnode));
        p->next = NULL;
        if (val == START)
          {
            p->type = list;
            p->data.first = mklist();
          }
        else
          {
            p->type = atom;
            p->data.value = val;
          }
        if (oldp != NULL) oldp->next = p;
        else head = p;
      }
    return head;
  }

int main(void)
  {
    NODEPTR root;

    root = mklist();
    printlist(root);
  }
