#include <math.h>
#include <stdio.h>
#define  STEP1           2.0
#define  STEP2           0.5
#define  TOTALTIME       100
#define  THRESHOLD       75
#define  YES             1
#define  NO              0

int main(void)
  {
    double  t, acceleration, velocity, height,
            step, previous_height;
    int     descending;

    for (t=0, step=STEP1, descending=NO,
	     previous_height=0; t <= TOTALTIME; t += step)
      {
        acceleration = 4.25 - 0.015 * t * t +
            (6.07 * pow(t,2.751)) / 9995;
        velocity = 4.25 * t - (0.015 * t * t * t) / 3 +
            (6.07 * pow(t,3.751)) / (3.751 * 9995);
        height = 90 + (4.25* t * t) / 2 -
            (0.015 * pow(t,4.0)) / 12 +
            (6.07 * pow(t,4.751)) / (4.751 * 37491);

        if (height <= 0)
          {
            printf(
              "rocket impacted at or before %f\n", t);
            break;
          }
        else
            printf("%f %f %f %f\n",
                   t, acceleration, velocity, height);

        if (height < previous_height)
            descending = YES;
        else
            previous_height = height;

        if (descending && height <= THRESHOLD)
            step = STEP2;

      }

    return 0;
  }
