/* A recursive function to convert an infix expression
   into its equivalent postfix form.
  
   Input:
   a/a * a/a
   a+ b/c -d
   ( a / b)* c-d
   (a+b)*(c-d)
   a+b  * (c-d)
   b+c*(d+c*a*a)*b+a

   Output:
   aa/a*a/
   abc/+d-
   ab/c*d-
   ab+cd-*
   abcd-*+
   bcdca*a*+*b*+a+
*/

#include <stdio.h>
#define  SEPARATOR  ' '

void expr(void), term(void), factor(void), locate(void);
int c;

int main(void)
  {
    locate();
    while (c != EOF)
      {
        expr();
      }
    return 0;
  }

void expr(void)
  {
    char op;

    term();
    while (c == '+' || c == '-')
      {
        op = c;
        locate();
        term();
        printf("%c", op);
      }
  }
 
void term(void)
  {
    char op;

    factor();
    while (c == '*' || c == '/')
      {
        op = c;
        locate();
        factor();
        printf("%c", op);
      }
  }
 
void factor(void)       
  {
    if (c == '(')
      {
        locate();
        expr();
        /* c at this stage is ')' */
      }
    else
        printf("%c", c);
    locate();
  }

void locate(void)
  {
    while (c = getchar(), c == SEPARATOR && c != EOF) ;
  }
