#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define  MAXLEN  80

char *convert(int number, int base, char *string);
char *strrev(char *string);

int main(int argc, char **argv)
  {
    int  binary = 0, octal = 0, hex = 0, i;
    char c, *cp, *name, str[MAXLEN];

    name = *argv++, argc--;

    for (; argc > 0 && **argv == '-'; argc--, argv++)
      {
        cp = *argv;
        while (c = *++cp)
            switch (c)
              {
                case 'b':
                    binary = 1;
                    break;
                case 'o':
                    octal = 1;
                    break;
                case 'x':
                    hex = 1;
                    break;
                default:
                    printf("%s: illegal option"
                           "%c\n", name, c);
                    argc = 0;
                    break;
              }
      }

    if (argc != 1)
      {
        printf("usage: %s -box <integer>\n", name);
        return 1;
      }
        
    i = atoi(*argv);

    if (binary)
        printf("binary: %s\n", convert(i, 2, str));
    else if (octal)
        printf("octal: %s\n", convert(i, 8, str));
    else /* hex */
        printf("hex: %s\n", convert(i, 16, str));

    return 0;
  }

char *convert(int num, int base, char *str)
  {
    char *sp = str;
    int digit;

    do
      {
        digit = num % base;
        *sp++ = digit < 10 ?
                digit + '0' : digit - 10 + 'a';
        num /= base;
      }
    while(num);

    *sp = '\0'; /*  null terminate str */

    return strrev(str);
  }

char *strrev(char *str)  /*  reverse str in place */
  {
    char *left = str,
         *right = str + strlen(str) - 1, temp;

    for ( ; left < right; left++, right--)
         temp = *left, *left = *right, *right = temp;

    return str;
  }
