#include <stdio.h>
#include <stdlib.h>

float *alloc(char *name, int rows, int cols);
void  readm(float *matrix, int rows, int cols);
void  writem(float *matrix, int rows, int cols);
void  multiply(float *matrix1, int rows1, int cols1,
               float *matrix2, int cols2,
               float *product);

int main(void)
  {
    float  *matrix1, *matrix2, *product;
    int    rows1, cols1, rows2, cols2;

    for(;;)
      {
        /* get the actual dimensions of the matrices */

        printf("dimensions of matrix1?\n");
        scanf("%d %d", &rows1, &cols1);
        printf("dimensions of matrix2?\n");
        scanf("%d %d", &rows2, &cols2);

        if (cols1 != rows2)
          {
            printf("columns in matrix1 must "
                   "equal rows in matrix2\n");
            continue;
          }

        /* allocate space for matrices */
        matrix1 = matrix2 = product = NULL;

        if ((matrix1 =
               alloc("matrix1", rows1, cols1)) &&
            (matrix2 =
               alloc("matrix2", rows2, cols2)) &&
            (product =
               alloc("product", rows1, cols2)))
                   break;
        else
            free(matrix1), free(matrix2),
            free(product);
      }
       

    /* read the matrices */

    printf("enter row-wise "
           "the elements of matrix1\n");
    readm(matrix1, rows1, cols1);

    printf("enter row-wise "
           "the elements of matrix2\n");
    readm(matrix2, rows2, cols2);

    /* compute the product matrix */

    multiply(matrix1, rows1, cols1,
             matrix2, cols2, product);

    /* print results */

    printf("product matrix:\n");
    writem(product, rows1, cols2);

    free(matrix1), free(matrix2), free(product);

    return 0;

  }

float *alloc(char *name, int rows, int cols)
  {
    float *matrix;

    matrix =
        (float *)calloc(rows, cols * sizeof(float));
    if (!matrix)
        printf("%s is too big\n", name);

    return matrix;
  }

void readm(float *matrix, int rows, int cols)
  {
    float *last = matrix + rows * cols;

    while (matrix < last)
        scanf("%f", matrix++);
  }

void multiply(float *matrix1, int rows1, int cols1,
              float *matrix2, int cols2,
              float *product)
  {
    int i, j, k;

    for (i = 0; i < rows1; i++)
        for (j = 0; j < cols2; j++)
          {
            for (k = 0, *product = 0; k < cols1; k++)
                /* p[i,j] += m1[i,k] * m2[k,j] */
                *product += matrix1[i * cols1 + k] *
                            matrix2[k * cols2 + j];
            product++;
          }
  }

void writem(float *matrix, int rows, int cols)
  {
    int i;

    for (i = 1; i <= rows*cols; i++)
     {
        printf("%f ", *matrix++);
        if (i % cols == 0) /* end of a row */
            printf("\n");;
      }
  }
