/******************   stack.c   ******************/

#include "global.h"
#define  STACKSIZE  80

int  stack[STACKSIZE];
int  *sp = stack;  /* pointer to the current top of the stack */

static int stackfull(void), stackempty(void);

void clearstack(void)
  {
    sp = stack;
  }

void push(int n)
  {
    error = 0;

    if (stackfull())
        error = STACKFULL;
    else
        /* put n on the stack and increment sp */
        *sp++ = n;
  }

int pop(void)
  {
    error = 0;

    if (stackempty())
      {
        error = STACKEMPTY;
        return 0;
      }
    else
        /* decrement sp and return what it is pointing to */
        return *--sp;
  }

int stacksize(void)
  {
    return sp - stack;
  }

void printstack(void)
  {
    int i = stacksize();

    printf("stack: ");
    while (i) printf("%d ", stack[--i]);
    printf("\n");
  }

static int stackfull(void)
  {
    return sp >= stack + STACKSIZE ? 1 : 0;
  }

static int stackempty(void)
  {
    return sp == stack ? 1 : 0;
  }
