/*******************   main.c   ******************/

#include "global.h"

char *data[MAXLINES]; /* pointer array to hold data lines */

int main(int argc, char **argv)
  {
    int  numeric = 1; /* the default is a numerical sort */
    int  lines;       /* the number of data lines in input */

    if (argc > 1) /* ensure that the -l option has been specified */
        if (lexcmp(*(argv+1), "-l") == 0)
            numeric = 0;
        else
          {
            printf("usage: %s [-l]\n", *argv);
            return 1;
          }

    /* read data */
    lines = getdata(data, MAXLINES);

    if (lines > 0)
      {
        /* sort data and print result */
        bsort(data, lines, numeric ? intcmp : lexcmp);
        printdata(data, lines);
        return 0;
      }
    else if (lines == 0)
      {
        printf("no data\n");
        return 1;
      }
    else
      {
        printf("too much data\n");
        return 1;
      }
  }

/* returns -1 if s1 < s2, 0 if s1 = s2, and 1 if s1 > s2 */

int intcmp(char *s1, char *s2)
  {
    int i = atoi(s1), j = atoi(s2);

    return i > j ? 1 : i < j ? -1 : 0;
  }

/* returns < 0 if s1 < s2, 0 if s1 = s2, and > 0 if s1 > s2 */

int lexcmp(char *s1, char *s2)
  {
    for ( ; *s1 == *s2; s1++, s2++)
        if (*s1 == '\0') return 0;

    return *s1 - *s2;
  }
