/*****************   complex.c   *****************/

#include "global.h"

struct complex add(struct complex u,
                   struct complex v)
  {
    struct complex z;

    z.x = u.x + v.x;
    z.y = u.y + v.y;
    return z;
  }

struct complex subtract(struct complex u,
                        struct complex v)
  {
    struct complex z;

    z.x = u.x - v.x;
    z.y = u.y - v.y;
    return z;
  }

struct complex multiply(struct complex u,
                        struct complex v)
  {
    struct complex z;

    z.x = u.x * v.x - u.y * v.y;
    z.y = u.x * v.y + u.y * v.x;
    return z;
  }

struct complex divide(struct complex u,
                      struct complex v)
  {
    v.x /= v.x * v.x + v.y * v.y;
    v.y /= - (v.x * v.x + v.y * v.y);
    return multiply(u, v);
  }

int equal(struct complex u, struct complex v)
  {
    return u.x == v.x && u.y == v.y;
  }

void readc(struct complex *u)
  {
    scanf("%f %f", &u->x, &u->y);
  }

void writec(struct complex *u)
  {
    printf("(%f, %f)", u->x, u->y);
  }
